Things to check before reporting an issue
-----------------------------------------

1. Make sure the bug has not already been reported and search in the issue tracker for similar issue.
2. If you're experiencing a crash of the application and are using open source NVIDIA drivers on GNU/Linux: please first try the proprietary NVIDIA drivers before reporting.
3. If you're experiencing a crash of the application and are using the proprietary NVIDIA drivers: make sure you rebooted after your last NVIDIA driver update and make sure to run ``sudo nvidia-xconfig`` before reporting the issue

Reporting bugs or Wishes
------------------------

Report any bugs you encountered or any wishes on our [issue tracker](https://github.com/ColinDuquesnoy/MellowPlayer/issues).

If you're reporting a bug, **make sure to provide the following information**:

- Information about your **Operating system** (e.g. Windows 8.1, Mac OSX Yosemite,...). If you're on Linux, you'll need to specify the
  name of the distribution and the desktop environment you're using and whether you're using a native package or the AppImage.
- The **music streaming service** that you were using when you encountered the bug if related to a specific streaming service.
- A **clear description** of the bug with **steps to reproduce**.
- You should use **English** to describe your issue. French is also accepted.
- Paste the application log between triple backquotes ```(About > Show Logs)```.
